Public Class s3DateSubEditor

    Inherits Form
    Implements FarPoint.Win.Spread.CellType.ISubEditor

    Public Event CloseUp(ByVal sender As Object, ByVal e As EventArgs) Implements FarPoint.Win.Spread.CellType.ISubEditor.CloseUp
    Public Event ValueChanged(ByVal sender As Object, ByVal e As EventArgs) Implements FarPoint.Win.Spread.CellType.ISubEditor.ValueChanged
    Private BtnOk As Button = Nothing
    Private BtnCancel As Button = Nothing
    Private Cal As MonthCalendar = Nothing

    Public Sub New()
        FormBorderStyle = Windows.Forms.FormBorderStyle.FixedSingle
        MaximizeBox = False
        MinimizeBox = False
        ControlBox = False
        Cal = New MonthCalendar
        BtnOk = New Button()
        BtnCancel = New Button()

        Cal.Location = New Point(0, 0)
        Cal.Size = New Size(164, 155)

        BtnOk.Location = New Point(93, 169)
        BtnOk.Size = New Size(73, 29)
        BtnOk.Text = "&Ok"
        BtnOk.DialogResult = Windows.Forms.DialogResult.OK

        BtnCancel.Location = New Point(14, 169)
        BtnCancel.Size = New Size(73, 29)
        BtnCancel.Text = "&Abbruch"
        BtnCancel.DialogResult = Windows.Forms.DialogResult.Cancel

        Me.AcceptButton = BtnOk
        Me.CancelButton = BtnCancel

        Controls.Add(Cal)
        Controls.Add(BtnOk)
        Controls.Add(BtnCancel)
        Text = "Editor"
        AddHandler BtnOk.Click, AddressOf OK_Clicked
        AddHandler BtnCancel.Click, AddressOf Close_Clicked
        AddHandler Cal.DateChanged, AddressOf txt_TextChanged
        AddHandler Cal.DateSelected, AddressOf txt_TextChanged

    End Sub

    Private Sub OK_Clicked(ByVal sender As Object, ByVal e As EventArgs)
        RaiseEvent ValueChanged(Me, EventArgs.Empty)
        RaiseEvent CloseUp(Me, EventArgs.Empty)
    End Sub

    Private Sub Close_Clicked(ByVal sender As Object, ByVal e As EventArgs)
        RaiseEvent CloseUp(Me, EventArgs.Empty)
    End Sub

    Private Sub txt_TextChanged(ByVal sender As Object, ByVal e As DateRangeEventArgs)
        Text = Format(Cal.SelectionStart, "dd/MM/yyyy")
    End Sub

    Public Function GetLocation(ByVal rect As Rectangle) As Point Implements FarPoint.Win.Spread.CellType.ISubEditor.GetLocation
        Dim pt As New Point(0)
        Dim sz As Size = GetPreferredSize()
        pt.Y = (Screen.PrimaryScreen.WorkingArea.Height / 2) - (sz.Height / 2)
        pt.X = (Screen.PrimaryScreen.WorkingArea.Width / 2) - (sz.Width / 2)
        Return pt
    End Function

    Public Shadows Function GetPreferredSize() As Size Implements FarPoint.Win.Spread.CellType.ISubEditor.GetPreferredSize
        Return New Size(180, 229)
    End Function

    Public Function GetSubEditorControl() As Control Implements FarPoint.Win.Spread.CellType.ISubEditor.GetSubEditorControl
        Return Me
    End Function

    Public Function GetValue() As Object Implements FarPoint.Win.Spread.CellType.ISubEditor.GetValue
        Return Cal.SelectionStart.Date
    End Function

    Public Sub SetValue(ByVal value As Object) Implements FarPoint.Win.Spread.CellType.ISubEditor.SetValue

        If IsDate(value) Then
            Cal.SelectionStart = value
            Try
                Cal.SelectionEnd = Cal.SelectionStart
            Catch
                Cal.SelectionEnd = Cal.MinDate
            End Try

        Else
            Cal.SelectionStart = Now
            Cal.SelectionEnd = Cal.SelectionStart
        End If
    End Sub

    Private Sub InitializeComponent()
        Me.SuspendLayout()
        '
        'mySubEditor
        '
        Me.ClientSize = New System.Drawing.Size(292, 302)
        Me.Name = "mySubEditor"
        Me.ResumeLayout(False)

    End Sub
End Class
